/* =========================================================================

InDesign ExtendScript

NAME: InCountChars
VERSION: 1.1

AUTHOR: Vitaly Batushev
DATE  : 11.08.2005

DESCRIPTION: Статистика о количестве знаков в публикации

SUPPORT: http://indesign.rudtp.ru
E-MAIL: vbatushev@indesign.rudtp.ru

============================================================================ */
with (app) {
var ScriptName = getFileNameOnly(app.activeScript.name) + ' 1.1';
try {		
	if (app.version.substr(0,1) > 3 ) {
		$.locale = "ru";
		//$.localize = true;
		var strMinWords = localize({en: 'Minimum words in Story', ru: 'Минимальное количество слов в статье:'});
		var strViewWithOutSpaces = localize({en: 'Minimum words in Story', ru: 'Показывать количество знаков без пробелов'});
		var strAttention = localize({en: 'Attention!', ru: 'Внимание!'});
		var strNoOpenDocument = localize({en: 'No open documents!', ru: 'Нет открытых документов!'});
		var strReport = localize({en: 'Report', ru: 'Статистический отчет'});
		var strPublication = localize({en: 'Publication', ru: 'Название публикации'});
		var strCharsWithSpaces = localize({en: 'characters with spaces', ru: 'символов, включая пробелы'});
		var strCharsWithoutSpaces = localize({en: 'characters without spaces', ru: 'символов, не включая пробелы'});
		var strAuthorLists = localize({en: 'Authors lists', ru: 'Авторских листов'});
		var strLessOneList = localize({en: 'less than one authors list', ru: 'менее одного авторского листа'});
		var strSaveReport = localize({en: 'Save report in file?', ru: 'Сохранить отчет в файл?'});
		var strTextFiles = localize({en: 'Text Files', ru: 'Текстовые файлы'});
		var strSelectResultFile = localize({en: 'Save Result File', ru: 'Сохранить результат'});
		var strEndWork = localize({en: 'Report created!', ru: 'Создание отчета завершено!'});
		var strNoSaveFile = localize({en: 'File is not saved', ru: 'Файл не сохранен!'});
		var strFileSaveAs = localize({en: 'File save as', ru: 'Файл сохранен как'});
		var strCreatedWith = localize({en: 'Created with script', ru: 'Создано с помощью скрипта'});
		var strCredits = localize({en: 'by Vitaly Batushev (http://indesing.rudtp.ru)', ru: 'Виталий Батушев (http://indesing.rudtp.ru)'});
		var strBars = localize({en: '===============================', ru: '==============================='});
	} else {
		var strMinWords = 'Minimum words in Story';
		var strViewWithOutSpaces = 'Minimum words in Story';
		var strAttention = 'Attention!';
		var strNoOpenDocument = 'No open documents!';
		var strReport = 'Report';
		var strPublication = 'Publication';
		var strCharsWithSpaces = 'characters with spaces';
		var strCharsWithoutSpaces = 'characters without spaces';
		var strAuthorLists = 'Authors lists';
		var strLessOneList = 'less than one authors list';
		var strSaveReport = 'Save report in file?';
		var strTextFiles = 'Text Files';
		var strSelectResultFile = 'Save Report File';
		var strEndWork = 'Report created!';
		var strNoSaveFile = 'File is not saved';
		var strFileSaveAs = 'File save as';
		var strCreatedWith = 'Created with script';
		var strCredits = 'by Vitaly Batushev (http://indesing.rudtp.ru)';
		var strBars = '===============================';
	}
} catch (e) {
	var strMinWords = 'Minimum words in Story';
	var strViewWithOutSpaces = 'Minimum words in Story';
	var strAttention = 'Attention!';
	var strNoOpenDocument = 'No open documents!';
	var strReport = 'Report';
	var strPublication = 'Publication';
	var strCharsWithSpaces = 'characters with spaces';
	var strCharsWithoutSpaces = 'characters without spaces';
	var strAuthorLists = 'Authors lists';
	var strLessOneList = 'less than one authors list';
	var strSaveReport = 'Save report in file?';
	var strTextFiles = 'Text Files';
	var strSelectResultFile = 'Save Report File';
	var strEndWork = 'Report created!';
	var strNoSaveFile = 'File is not saved';
	var strFileSaveAs = 'File save as';
	var strCreatedWith = 'Created with script';
	var strCredits = 'by Vitaly Batushev (http://indesing.rudtp.ru)';
	var strBars = '===============================';
}
	if (documents.length < 1) { alert(strNoOpenDocument, strAttention); exit(); }
	var myDoc = activeDocument;	
	var myDlg = dialogs.add({name:ScriptName});
	with(myDlg) {
		with(dialogColumns.add()) {
			with (borderPanels.add()) {
				staticTexts.add({staticLabel:strMinWords});
				var minWords = integerEditboxes.add({editValue:0, minWidth:25});
			}
			var chkWithOutSpace = checkboxControls.add({staticLabel:strViewWithOutSpaces, checkedState:false})
		}
	}
	result = myDlg.show();
	if (result == false) { myDlg.destroy(); exit();	}
	var fullCount = 0;
	var spaceCount = 0;
	for (i = 0; i < myDoc.stories.length; i++) {
		var myStory = myDoc.stories[i];
		if (myStory.words.length > minWords.editValue) {
			fullCount = fullCount + myStory.characters.length;
			if (chkWithOutSpace.checkedState == true ){
				var  re = /\s/g;
				try {
					var tmpSpace = myStory.contents.match(re);
				} catch (e) {}
				if (tmpSpace != null) { spaceCount = spaceCount + tmpSpace.length; }
			}
			if (myStory.tables.length > 0) {
				for (ti = 0; ti < myStory.tables.length; ti++) {
					var myTable = myStory.tables[ti];
					for (j = 0; j < myTable.cells.length; j++) {
						fullCount = fullCount + myTable.cells[j].characters.length;
						if (chkWithOutSpace.checkedState == true ){ 
							try {
								var tmpSpace = myTable.cells[j].contents.match(re);
							} catch (e) {}
							if (tmpSpace != null) { spaceCount = spaceCount + tmpSpace.length; }
						}
					}
				}
			}
		}
	}
	var aList = Math.round(fullCount/40000);
	if (aList < 1) { aList = strLessOneList };
	var txtReport = strBars + '\n' + strReport + '\n' + strBars + '\n\n' + 
	strPublication + ': ' + activeDocument.name + '\n\n' +
	fullCount + ' ' + strCharsWithSpaces + '.' + '\n';
	if (chkWithOutSpace.checkedState == true ){
		txtReport = txtReport + (fullCount - spaceCount) + ' ' + strCharsWithoutSpaces + '.' + '\n\n';
	}
	txtReport = txtReport + strAuthorLists + ': ' + aList + '.' + '\n\n\n\n' + strBars + '\n' + 
	strCreatedWith + ' ' + ScriptName + '\n' + strCredits;
	alert (txtReport, ScriptName);

	var myResultFile = new File (activeDocument.filePath + "/Otchet.txt");
	myResultFile.encoding = 'UTF16';	
	myResultFile.open("w");		
	myResultFile.write(txtReport);
	myResultFile.close();	
	myResultFile.execute();
	
	/*
	var result = confirm(strSaveReport, strAttention);	
	if (result == true) {
		var myResultFile = File.saveDialog(strSelectResultFile, strTextFiles + ': *.txt');
		myResultFile.encoding = 'UTF16';
		resul = myResultFile.open('w');
		if (resul == true) {
			newresult = myResultFile.write(txtReport);
			alert(strEndWork + '\n' + strFileSaveAs + ' ' + myResultFile.name);
			myResultFile.close();
			myResultFile.execute();
		} else {
			myResultFile.close();
			alert(strNoSaveFile);
		}
	} */
}
function getFileNameOnly (myFileName) {
	var myString = "";
	var myResult = myFileName.lastIndexOf(".");
	if (myResult == -1) { myString = myFileName; }
	else { myString = myFileName.substr(0, myResult); }
	return myString;
}